<?php
/**
 * @version		$Id: loadmodule.php 21097 2011-04-07 15:38:03Z dextercowley $
 * @package		Joomla.Plugin
 * @subpackage	Content.loadmodule
 * @copyright	Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */
// no direct access
defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');
class plgContentLoadsoundcloud extends JPlugin
{
	public function onContentPrepare($context, &$article, &$params, $page = 0) //j1.6
	{
		// simple performance check to determine whether bot should process further
		if (strpos($article->text, '://soundcloud.com/') === false) {
			return true;
		}
		 $mode		= $this->params->def('mode',1);
		 $auto_play			= $this->params->def('auto_play',false);
		 $show_comments		= $this->params->def('show_comments',false);
		 $showdescription		= $this->params->def('showdescription',1);
		 $color		= $this->params->def('color','3B5998');
		 $player_height		= $this->params->def('player_height','200');
		if($mode==1)
			$regex			= '/{https?:\/\/soundcloud.com\/+(.*?)}/i';   //{http://soundcloud.com/blabla/moi}
		elseif($mode==2)
			$regex			=   '/https?:\/\/soundcloud.com\/+(.*?)\s/i'; //http://soundcloud.com/blabla/moi
		elseif($mode==3)
			$regex			= '/{soundcloud\s+(.*?)}/i';   //{http://soundcloud.com/blabla/moi}
		$matches	= array();
		// find all instances of plugin and put in $matches
		preg_match_all($regex, $article->text, $matches, PREG_SET_ORDER);

		foreach ($matches as $match) {
			//if(substr_count($match[1] ,'/')==1)
				//$player_height='81';
			// $match[0] is full pattern match, $match[1] is the position
			$output = $this->_load($match[1],$mode,$player_height,$auto_play,$show_comments,$showdescription,$color);
			// We should replace only first occurrence in order to allow positions with the same name to regenerate their content:
			$article->text = preg_replace("|$match[0]|", $output, $article->text, 1);
		}
	}
	protected function _load($url,$mode,$player_height,$auto_play,$show_comments,$showdescription,$color)
	{
		$url=urlencode($url);
		
		//echo $mode;
	
						
		$html = '<div>';
		
		$zurl = 'https://soundcloud.com/oembed?url=https%3A//soundcloud.com/'.$url;
		if( $auto_play == 1)
				$zurl =  $zurl."&auto_play=true";
		else
				$zurl =  $zurl."&auto_play=false";
		if( $show_comments)
				$zurl =  $zurl."&show_comments=true";
		else
				$zurl =  $zurl."&show_comments=false";
		$color	= trim($color);
		if( !empty($color))
				$zurl .= "&color=".$color;
		$zurl .= "&maxheight=".$player_height ;
		$result =   simplexml_load_file($zurl);
		if( $showdescription )
				$html .= $result->description;
		 $html .= $result->html;
		$html .= '</div>';
		$return = $html;
		
		
		return $return;
	}
}
